#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
void speed()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
const int maxn=1e6+100;
int tree[maxn],a[maxn];
int n,k;
vector<int> bits[32];
/*void build(int l,int r,int i)
{
    if(l==r)
    {
        tree[i]=a[l];
        return;
    }
    int m=(l+r)/2;
    build(l,m,i*2);
    build(m+1,r,i*2+1);
    tree[i]=tree[i*2]|tree[i*2+1];
}
int query(int l,int r,int i,int ql,int qr)
{
    if(r<ql||qr<l) return 0;
    if(ql<=l&&r<=qr)
    {
        return tree[i];
    }
    int m=(l+r)/2;
    query()
}*/
bool get_bit(int num,int bit)
{
    return num&(1<<num);
}
void read()
{
    cin>>n>>k;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
        for(int bit=0;bit<=29;bit++)
        {
            if(get_bit(a[i],bit))
            {
                bits[bit].push_back(i);
            }
        }
    }
    /*for(int bit=0;bit<=29;bit++,cout<<endl)
    {
        cout<<bit<<' ';
        for(int i=0;i<bits[bit].size();i++)
        {
            cout<<bits[bit][i]<<' ';
        }
    }*/
}
int L[maxn],R[maxn];
int ans[maxn];
int check(int l,int r,int bit1)
{
    for(int bit=bit1-1;bit>=1;bit--)
    {
        if()
    }
}
int bin(int i,int l,int r,int bit)
{   
    int ans=0;
    while(l<=r)
    {
        int m=(l+r)/2;
        if(ans<check(m))
        {
            ans=m;
            r=m-1;
        }else l=m+1;
    }
}
void solve()
{   
    for(int bit=29;bit>=0;bit--)
    {
        if(bits[bit].size()<k)
        {
            continue;
        }
        for(int i=1;i<=k;i++)
        {   
            
        }
    }
}
int main()
{
    speed();

    return 0;
}
